--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_tx-host.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_tx-host.c	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,1209 @@
+/* Name: mausb_tx-host.c 
+ * Description: implement host-side Ma USB transfers 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#include <linux/kthread.h> 
+ 
+#include "mausb_hcd.h" 
+#include "mausb_pkt.h" 
+#include "mausb_tx.h" 
+ 
+/** 
+ * Handles a data transfer timeout event, then sleeps until the next 
+ * timeout event. Timeout events that wish to use this thread should 
+ * set the ep->tx_timed_out flag to true to ensure that the thread 
+ * is woken. 
+ */ 
+int host_transfer_timeout(void *data) 
+{ 
+ int err = 0; 
+ int dir_in = 0; 
+ int seq_num = 0; 
+ struct mausb_host_ep *ep = (struct mausb_host_ep *) data; 
+ struct mausb_ep_state *ep_state = &ep->state; 
+ struct mausb_transfer_state *tx_state; 
+ struct mausb_pkt *tx_req; 
+ unsigned long irq_flags; 
+ struct mausb_hcd *mhcd = mausb_host_ep_to_mahcd(ep); 
+ 
+ while (!kthread_should_stop()) { 
+ 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ /* 
+ * make sure there is an active transfer for timeout 
+ * to handle (i.e. not thread creation/initialization) 
+ */ 
+ if (ep->active_transfer && ep->active_transfer->urb) { 
+ tx_state = &ep->active_transfer->state; 
+ dir_in = usb_pipein(ep->active_transfer->urb->pipe); 
+ 
+ seq_num = ep_state->earliest_unacked; 
+ 
+ if (ep_state->retry_counter > 0) { 
+ mausb_dbg(mhcd, "%s: host timed out waiting" 
+ " for pkt %i\n", __func__, seq_num); 
+ 
+ /* see if we have corresponding request */ 
+ err = mausb_resend_multi_packets(ep, 
+ &ep->req_list, seq_num, irq_flags); 
+ 
+ /* if not, send new req */ 
+ if (err != 0) { 
+ spin_unlock_irqrestore(&ep->ep_lock, 
+ irq_flags); 
+ 
+ tx_req = mausb_create_dp(NULL, 
+ ep->active_transfer, 
+ MAUSB_IN, MAUSB_HOST, 
+ GFP_ATOMIC); 
+ 
+ tx_req->data->common.pkt_type = 
+ TransferReq; 
+ tx_req->data->seq_num = seq_num; 
+ tx_req->data->common.pkt_status = 
+ SUCCESS; 
+ tx_req->data->req_id = 
+ ep_state->active_request_id; 
+ tx_req->common->ver_flags 
+ |= MAUSB_PKT_FLAG_RETRY; 
+ tx_req->common->length = 
+ mausb_pkt_length(tx_req); 
+ 
+ /* submit packet for transport */ 
+ mausb_transfer_data_pkt(tx_req, ep, 
+ GFP_ATOMIC); 
+ 
+ spin_lock_irqsave(&ep->ep_lock, 
+ irq_flags); 
+ 
+ list_add_tail(&tx_req->pkt_list, 
+ &ep->req_list); 
+ } 
+ 
+ ep_state->retry_counter--; 
+ } else { 
+ /* 
+ * Can optionally initiate ping process in sec 
+ * 5.2.3 of spec. For now we just treat as if 
+ * ping protocol failed. */ 
+ tx_state->transfer_error = true; 
+ 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ mausb_unlink_giveback_urb(ep->active_transfer, 
+ -ETIMEDOUT); 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ } 
+ } 
+ 
+ ep->tx_timed_out = false; 
+ 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ 
+ /* put thread to sleep to wait for next timeout event */ 
+ wait_event_interruptible(ep->host_ep_wq, 
+ kthread_should_stop() || ep->tx_timed_out); 
+ } 
+ 
+ return 0; 
+} 
+ 
+/* Initialize transfer state, for beginning a new transfer */ 
+static void mausb_host_init_tx_state(struct mausb_transfer_state *tx_state, 
+ u32 tx_size) 
+{ 
+ tx_state->transfer_error = false; 
+ tx_state->transfer_complete = false; 
+ tx_state->eot_detected = false; 
+ tx_state->transfer_acked = false; 
+ tx_state->rem_size = tx_size; 
+ tx_state->payload_size = 0; 
+} 
+ 
+/*--------------------- IN transfers ------------------------------*/ 
+ 
+/** 
+ * Host-side IN transfer initialization process. 
+ * 
+ * @tx_state: Transfer state to be initialized. 
+ * @ep_state: Endpoint state to be initialized. 
+ * @maurb: maurb associated with transfer. 
+ * 
+ * Called whenever a new IN transfer is initiated by the host. 
+ * Initializes transfer state variables, resets timers, then submits a 
+ * transferReq packet to the device side driver. After successful submission 
+ * of a transferReq packet, the transfer request id is incremented by one 
+ * for the next transfer. When transfer request id reaches its max value, 
+ * it wraps back around to zero (per mausb spec requirements). 
+ */ 
+void host_init_IN_transfer(struct mausb_transfer_state *tx_state, 
+ struct mausb_host_ep *ep, struct mausb_urb *maurb) 
+{ 
+ int status = SUCCESS; 
+ u32 tx_size = maurb->urb->transfer_buffer_length; 
+ unsigned long irq_flags; 
+ struct mausb_ep_state *ep_state = &ep->state; 
+ struct mausb_pkt *tx_req = mausb_create_dp(&status, maurb, 
+ MAUSB_IN, MAUSB_HOST, GFP_ATOMIC); 
+ 
+ if (!tx_req) 
+ return; 
+ 
+ mausb_fill_pkt_ep(tx_req, ep); 
+ 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ 
+ /* fill the transfer request */ 
+ tx_req->data->common.pkt_type = TransferReq; 
+ tx_req->data->remaining_size_credit = 
+ maurb->urb->transfer_buffer_length; 
+ tx_req->data->req_id = ep_state->request_id; 
+ tx_req->data->seq_num = cpu_to_le32(ep_state->seq_number); 
+ 
+ if (mausb_pkt_has_setup_data(tx_req->data)) { 
+ tx_req->setup = 
+ (struct usb_ctrlrequest *) maurb->urb->setup_packet; 
+ } 
+ 
+ tx_req->common->length = mausb_pkt_length(tx_req); 
+ 
+ /* set the transfer state */ 
+ mausb_host_init_tx_state(tx_state, tx_size); 
+ 
+ /* set the endpoint state */ 
+ ep->tx_timed_out = false; 
+ ep_state->active_request_id = ep_state->request_id; 
+ ep_state->keep_alive_timer = MAUSB_TRANSFER_TIMEOUT; 
+ ep_state->retry_counter = MAUSB_BULK_TRANSFER_RETRIES; 
+ ep_state->request_id = mausb_req_id_add(ep_state->request_id, 1); 
+ 
+ /* send the packet */ 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ host_IN_txReq_transmit(tx_req, ep, tx_state); 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ 
+ /* start timeout timer */ 
+ mod_timer(&ep->timer, 
+ jiffies + msecs_to_jiffies(ep_state->keep_alive_timer)); 
+ 
+ /* add the packet to the endpoint */ 
+ list_add_tail(&tx_req->pkt_list, &ep->req_list); 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+} 
+ 
+/** 
+* Releases an MA USB packet to the data channel and updates state. 
+*/ 
+void host_IN_txReq_transmit(struct mausb_pkt *tx_req, struct mausb_host_ep *ep, 
+ struct mausb_transfer_state *tx_state) 
+{ 
+ int ret; 
+ struct mausb_hcd *mhcd = mausb_host_ep_to_mahcd(ep); 
+ 
+ mausb_dbg(mhcd, "%s: sending pkt %i for request %i\n", __func__, 
+ le32_to_cpu(tx_req->data->seq_num), tx_req->data->req_id); 
+ 
+ /* submit packet for transport */ 
+ ret = mausb_transfer_data_pkt(tx_req, ep, GFP_ATOMIC); 
+ 
+ if (tx_state->eot_detected && !tx_state->transfer_error) 
+ if (tx_state->last_transfer_sn 
+ < le32_to_cpu(tx_req->data->seq_num)) { 
+ tx_state->transfer_acked = true; 
+ /* TODO:transfer_completion_timer = aMaxTransferLifetime */ 
+ } 
+} 
+ 
+/** 
+ * Transmits a TransferAck packet. 
+ * 
+ * @tx_state: State information associated with this transfer. 
+ * @in: Set to true for an IN transfer. 
+ * @ep_state: State information associated with transfer endpoint. 
+ * @status: Status to fill transferAck packet status field. 
+ * Note: unless otherwise specified in spec, should be SUCCESS. 
+ * @seq_num: Sequence number to fill transferAck packet sequence number field. 
+ * Note: should be the greatest sequence number of the packets to 
+ * be acked. 
+ * 
+ * Called to acknowledge end of transfer or when a packet that otherwise 
+ * requires acknowledgement (i.e. ARQ flag is set) is received. 
+ */ 
+int host_send_ack(struct mausb_transfer_state *tx_state, bool in, 
+ struct mausb_ep_state *ep_state, int status, u32 seq_num) 
+{ 
+ struct mausb_urb *maurb = container_of(tx_state, 
+ struct mausb_urb, state); 
+ struct mausb_host_ep *ep = mausb_state_to_ep(ep_state); 
+ struct mausb_pkt *tx_ack = mausb_create_dp(NULL, maurb, in, 
+ MAUSB_HOST, GFP_ATOMIC); 
+ struct mausb_hcd *mhcd = mausb_host_ep_to_mahcd(ep); 
+ unsigned long irq_flags; 
+ 
+ if (tx_ack == NULL) 
+ return -ENOMEM; 
+ 
+ mausb_fill_pkt_ep(tx_ack, ep); 
+ 
+ tx_ack->data->common.pkt_type = TransferAck; 
+ tx_ack->data->seq_num = cpu_to_le32(seq_num); 
+ tx_ack->data->common.pkt_status = status; 
+ tx_ack->data->req_id = ep_state->active_request_id; 
+ tx_ack->common->length = cpu_to_le16(mausb_pkt_length(tx_ack)); 
+ 
+ mausb_dbg(mhcd, "%s: sending ack for transfer %i\n", 
+ __func__, ep_state->active_request_id); 
+ 
+ if (in && tx_state->eot_detected) { 
+ if (mausb_transfer_is_complete(tx_state, seq_num)) { 
+ tx_state->transfer_acked = true; 
+ /* TODO: set completion timer */ 
+ } 
+ 
+ /* since we're done, clear out packet lists and free memory */ 
+ mausb_cleanup_ma_packets(ep, seq_num, 
+ ep_state->earliest_request_id); 
+ 
+ } else if (!in) { 
+ tx_state->transfer_acked = true; 
+ /* TODO: set transfer completion timer = aMaxTransferLifetime */ 
+ } 
+ 
+ /* submit packet for transport */ 
+ mausb_transfer_data_pkt(tx_ack, ep, GFP_ATOMIC); 
+ 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ list_add_tail(&tx_ack->pkt_list, &ep->req_list); 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ 
+ return 0; 
+} 
+ 
+/** 
+ * Deliver payload from transferResp to target urb. 
+ * 
+ * @tx_resp: transferResponse packet with data to be transfered. 
+ * @maurb: urb associated with transfer. 
+ * 
+ * Must ensure that transfer has not been completed (transfer_complete is 
+ * false) and there are no transfer errors (transfer_error is false) before 
+ * calling. 
+ * 
+ * Returns length in bytes of data delivered. 
+ */ 
+int host_IN_deliver_payload(struct mausb_pkt *tx_resp, struct mausb_urb *maurb) 
+{ 
+ int offset; 
+ int length = tx_resp->buffer_length; 
+ struct mausb_hcd *mhcd = mausb_host_ep_to_mahcd(maurb->ep); 
+ 
+ if (length == 0) { 
+ mausb_err(mhcd, "%s: no payload (length = 0)\n", __func__); 
+ return length; 
+ } 
+ 
+ if (!maurb || !maurb->urb || !maurb->urb->transfer_buffer) { 
+ mausb_err(mhcd, "%s: urb not found\n", __func__); 
+ return -EINVAL; 
+ } 
+ 
+ if (!tx_resp || !tx_resp->buffer) { 
+ mausb_err(mhcd, "%s: no transferResponse buffer\n", __func__); 
+ return -EINVAL; 
+ } 
+ 
+ offset = maurb->urb->transfer_buffer_length - maurb->state.rem_size; 
+ 
+ memcpy(maurb->urb->transfer_buffer + offset, tx_resp->buffer, length); 
+ 
+ maurb->urb->actual_length += length; 
+ 
+ return length; 
+} 
+ 
+/** 
+ * Determines if a received transfer response should be dropped 
+ * due to invalid request or sequence number. Note: this fuction does not 
+ * actually drop any packets. 
+ * 
+ * The caller should be holding the endpoints spinlock. 
+ * 
+ * Returns true if packet should be dropped, otherwise returns false. 
+ */ 
+bool should_drop_txResp(struct mausb_ep_state *ep_state, 
+ struct mausb_transfer_state *tx_state, 
+ struct mausb_pkt *tx_resp, bool in) 
+{ 
+ bool drop = false; 
+ u8 r = tx_resp->data->req_id; 
+ u32 SN = le32_to_cpu(tx_resp->data->seq_num); 
+ struct mausb_host_ep *ep = mausb_state_to_ep(ep_state); 
+ struct mausb_hcd *mhcd = mausb_host_ep_to_mahcd(ep); 
+ 
+ /* transfer is complete or error flag is set */ 
+ if (tx_state->transfer_complete || tx_state->transfer_error) { 
+ mausb_err(mhcd, "%s: transfer %i already completed %s error\n", 
+ __func__, r, 
+ (tx_state->transfer_error ? "with" : "without:")); 
+ drop = true; 
+ } 
+ 
+ /* request id is invalid */ 
+ if (mausb_req_id_lt(r, ep_state->earliest_request_id) || 
+ (mausb_req_id_gt_eq(r, ep_state->request_id))) { 
+ 
+ mausb_err(mhcd, "%s: request ID %i is invalid\n", __func__, r); 
+ 
+ host_send_ack(tx_state, MAUSB_IN, ep_state, 
+ INVALID_REQUEST, SN); 
+ drop = true; 
+ } 
+ 
+ /* 
+ * Sequence number is reserved for TRANSFER_PENDING, 
+ * so skip sequence number checks. 
+ */ 
+ if (TRANSFER_PENDING == tx_resp->common->pkt_status) 
+ return drop; 
+ 
+ /* sequence number is larger than expected */ 
+ if (mausb_seq_num_gt(SN, ep_state->seq_number)) { 
+ 
+ mausb_err(mhcd, "%s: missing sequence number - expected %i but" 
+ " received %i\n", __func__, ep_state->seq_number, SN); 
+ 
+ drop = true; 
+ host_send_ack(tx_state, MAUSB_IN, ep_state, 
+ MISSING_SEQUENCE_NUMBER, ep_state->seq_number); 
+ } 
+ 
+ /* sequence number is invalid */ 
+ if ((!in && mausb_seq_num_lt(SN, ep_state->earliest_unacked)) || 
+ (in && mausb_seq_num_lt(SN, ep_state->seq_number))) { 
+ 
+ mausb_err(mhcd, "%s: invalid sequence number %i for %s" 
+ " transfer\n", __func__, SN, (in ? "IN" : "OUT")); 
+ drop = true; 
+ } 
+ 
+ return drop; 
+} 
+ 
+/** 
+ * Handles receipt of transferResp. 
+ * 
+ * @ep_state: State information associated with transfer endpoint. 
+ * @tx_state: State information associated with transfer. 
+ * @tx_resp: transferResponse packet being received. 
+ * 
+ * Called when host receives a transferResp packet from a device during an IN 
+ * transfer. Updates host-side transfer and endpoint states and checks for 
+ * packet errors. 
+ * 
+ * Returns length of payload copied into host buffer. If nothing was copied 
+ * returns 0 or errno if error. 
+ */ 
+int host_IN_txResp_rcvd(struct mausb_ep_state *ep_state, 
+ struct mausb_transfer_state *tx_state, 
+ struct mausb_pkt *tx_resp) 
+{ 
+ int length = 0; 
+ u8 r = tx_resp->data->req_id; 
+ u8 eps_flags = tx_resp->data->eps_tflags; 
+ u32 payload_size = tx_resp->buffer_length; 
+ u32 SN = le32_to_cpu(tx_resp->data->seq_num); 
+ struct mausb_host_ep *ep = mausb_state_to_ep(ep_state); 
+ struct mausb_hcd *mhcd = mausb_host_ep_to_mahcd(ep); 
+ 
+ /* look for sequence number and request ID errors */ 
+ if (should_drop_txResp(ep_state, tx_state, tx_resp, MAUSB_IN)) { 
+ mausb_drop_packet(ep, tx_resp); 
+ return length; 
+ } 
+ 
+ switch (tx_resp->data->common.pkt_status) { 
+ case DROPPED_PACKET: 
+ mausb_dbg(mhcd, "%s: status = DROPPED_PACKET\n", __func__); 
+ mausb_drop_packet(ep, tx_resp); 
+ break; 
+ case INVALID_REQUEST: /* same as MISSING_REQUEST_ID in spec */ 
+ mausb_dbg(mhcd, "%s: status = INVALID_REQUEST\n", __func__); 
+ /* 
+ * TODO: invalidate all outstanding transferReqs with req id 
+ * from r to ep_state->request_id - 1 
+ */ 
+ ep_state->request_id = r; 
+ break; 
+ case TRANSFER_PENDING: 
+ mausb_dbg(mhcd, "%s: status = TRANSFER_PENDING\n", __func__); 
+ ep_state->keep_alive_timer = 
+ (tx_state->k * MAUSB_TRANSFER_KEEP_ALIVE); 
+ ep_state->retry_counter = ep_state->transfer_retries; 
+ if (eps_flags & MAUSB_PKT_TFLAG_ARQ) { 
+ /* 
+ * NOTE: per spec, the sequence number in the ack packet 
+ * is reserved and set to 0. 
+ */ 
+ host_send_ack(tx_state, MAUSB_IN, ep_state, 
+ TRANSFER_PENDING, 0); 
+ } 
+ break; 
+ case TRANSFER_EP_STALL: 
+ mausb_dbg(mhcd, "%s: status = TRANSFER_EP_STALL\n", __func__); 
+ if (eps_flags & MAUSB_PKT_TFLAG_EOT) { 
+ host_send_ack(tx_state, MAUSB_IN, ep_state, 
+ TRANSFER_EP_STALL, SN); 
+ 
+ tx_state->eot_detected = true; 
+ } 
+ break; 
+ case SUCCESS: 
+ ep_state->keep_alive_timer = MAUSB_TRANSFER_KEEP_ALIVE; 
+ ep_state->transfer_retries = MAUSB_BULK_TRANSFER_RETRIES; 
+ 
+ if (SN == ep_state->seq_number) { 
+ if (tx_state->rem_size >= payload_size) { 
+ length = host_IN_deliver_payload(tx_resp, 
+ container_of(tx_state, 
+ struct mausb_urb, state)); 
+ 
+ ep_state->seq_number++; 
+ tx_state->rem_size -= length; 
+ 
+ if (eps_flags & MAUSB_PKT_TFLAG_ARQ || 
+ eps_flags & MAUSB_PKT_TFLAG_EOT) { 
+ host_send_ack(tx_state, MAUSB_IN, 
+ ep_state, SUCCESS, SN); 
+ } 
+ 
+ if (eps_flags & MAUSB_PKT_TFLAG_EOT) { 
+ tx_state->eot_detected = true; 
+ tx_state->last_transfer_sn = SN; 
+ ep_state->earliest_request_id = 
+ mausb_req_id_add( 
+ ep_state->earliest_request_id, 
+ 1); 
+ ep_state->active_request_id = 
+ mausb_req_id_add( 
+ ep_state->active_request_id, 1); 
+ 
+ /* 
+ * Can optionally send ack here. 
+ * If don't send ack, next txReq 
+ * serves as ack. 
+ */ 
+ 
+ if (tx_state->rem_size > 0) { 
+ tx_state->transfer_error = true; 
+ mausb_dbg(mhcd, "%s: end of " 
+ "transfer with %i bytes left\n", 
+ __func__, tx_state->rem_size); 
+ } 
+ } 
+ } else { 
+ /* 
+ * For now just drop packet, but can also 
+ * optionally admit up to rem_size of payload 
+ * into buffer. 
+ */ 
+ tx_state->transfer_error = true; 
+ mausb_drop_packet(ep, tx_resp); 
+ host_send_ack(tx_state, MAUSB_IN, ep_state, 
+ TRANSFER_SIZE_ERROR, SN); 
+ } 
+ } 
+ break; 
+ default: 
+ mausb_dbg(mhcd, "%s: status = %i, dropping packet\n", 
+ __func__, tx_resp->data->common.pkt_status); 
+ mausb_drop_packet(ep, tx_resp); 
+ break; 
+ } 
+ 
+ return length; 
+} 
+ 
+ 
+/*------------------ protocol-managed OUT transfers -----------------*/ 
+ 
+/** 
+ * @ tx_state: Transfer state to be initialized. 
+ * @ ep: Endpoint associated with transfer. 
+ * @ tx_size: Transfer size in bytes. 
+ * 
+ * Called every time a new OUT transfer is initiated. Initializes transfer 
+ * state variables. 
+ */ 
+void host_init_OUT_transfer(struct mausb_transfer_state *tx_state, 
+ struct mausb_host_ep *ep, u32 tx_size) 
+{ 
+ unsigned long irq_flags; 
+ 
+ mausb_host_init_tx_state(tx_state, tx_size); 
+ 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ 
+ ep->tx_timed_out = false; 
+ 
+ ep->state.active_request_id = ep->state.request_id; 
+ 
+ /* 
+ * Increment request id for new transfer (or go back to zero 
+ * if max sequence number is reached. 
+ */ 
+ ep->state.request_id = mausb_req_id_add(ep->state.request_id, 1); 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+} 
+ 
+/** 
+ * Send a transferReq packet to a device. 
+ * 
+ * @tx_state: State variables for transfer. 
+ * @ep_state: State variables for endpoint associated with transfer. 
+ * @tx_req; MA USB transferReq packet to be sent out. 
+ */ 
+int host_OUT_send_txReq(struct mausb_transfer_state *tx_state, 
+ struct mausb_ep_state *ep_state, struct mausb_pkt *tx_req) 
+{ 
+ int i = 0; 
+ int payload_size = tx_req->buffer_length; 
+ int mausb_pkt_head_size; 
+ struct mausb_host_ep *ep = mausb_state_to_ep(ep_state); 
+ struct mausb_hcd *mhcd = mausb_host_ep_to_mahcd(ep); 
+ unsigned long irq_flags; 
+ 
+ mausb_pkt_head_size = mausb_pkt_header_length(tx_req->common); 
+ 
+ if (payload_size > ep_state->rx_buf_size) { 
+ mausb_dbg(mhcd, "%s: payload of %i bytes is too big - device " 
+ "can only receive %i bytes\n", __func__, payload_size, 
+ ep_state->rx_buf_size); 
+ while (payload_size > ep_state->rx_buf_size && 
+ i <= MAUSB_WAIT_GADGET_BUFFER_FREE_TIMEOUT) { 
+ msleep(1); 
+ i++; 
+ } 
+ if (i > MAUSB_WAIT_GADGET_BUFFER_FREE_TIMEOUT) { 
+ mausb_dbg(mhcd, 
+ "wait gadget receive buffer free time out\n"); 
+ return -ETIMEDOUT; 
+ } 
+ } 
+ 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ 
+ if (mausb_seq_num_lt(ep_state->seq_number, 
+ ep_state->earliest_unacked)) { 
+ 
+ mausb_err(mhcd, "%s: too many outstanding packets\n", 
+ __func__); 
+ /* TODO: transmit packet at later time (flow control) */ 
+ } 
+ 
+ if (payload_size <= ep_state->rx_buf_size) { 
+ /* 
+ * Credit remains less than 1 max_packet_payload, 
+ * and there are more than 1 max_packet_payload data to 
+ * transfer. Ask device to update credit. 
+ */ 
+ if (ep_state->rx_buf_size - payload_size < 
+ MAUSB_MAX_PACKET_SIZE - mausb_pkt_head_size && 
+ tx_state->rem_size > ep_state->rx_buf_size - payload_size) { 
+ mausb_dbg(mhcd, "request ARQ, payload_size: %d," 
+ " rx_buf_size: %d\n", payload_size, 
+ ep_state->rx_buf_size); 
+ tx_req->data->eps_tflags |= MAUSB_PKT_TFLAG_ARQ; 
+ } 
+ /* look for end of transfer */ 
+ if (tx_state->rem_size == 0) { 
+ tx_req->data->eps_tflags |= MAUSB_PKT_TFLAG_EOT; 
+ tx_req->data->eps_tflags |= MAUSB_PKT_TFLAG_ARQ; 
+ } 
+ 
+ /* set timer if expecting a response */ 
+ if (tx_req->data->eps_tflags & MAUSB_PKT_TFLAG_ARQ && 
+ le32_to_cpu(tx_req->data->seq_num) != 0) { 
+ tx_state->ack_transfer_sn = 
+ le32_to_cpu(tx_req->data->seq_num); 
+ mod_timer(&ep->timer, jiffies + 
+ msecs_to_jiffies(MAUSB_TRANSFER_TIMEOUT)); 
+ } 
+ 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ 
+ tx_req->common->length = cpu_to_le16(mausb_pkt_length(tx_req)); 
+ 
+ mausb_dbg(mhcd, "%s: sending transferRequest with sequence" 
+ " number %i for request %i with %i bytes of payload\n", 
+ __func__, le32_to_cpu(tx_req->data->seq_num), 
+ le32_to_cpu(tx_req->data->req_id), 
+ tx_req->buffer_length); 
+ 
+ tx_state->payload_size += payload_size; 
+ 
+ /* submit packet for transport */ 
+ mausb_transfer_data_pkt(tx_req, ep, GFP_ATOMIC); 
+ 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ 
+ ep_state->rx_buf_size -= payload_size; 
+ } 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ 
+ return 0; 
+} 
+ 
+/** 
+ * Determines if this urb is a for a control transfer. For host side only 
+ * (device doesn't have urbs). 
+ */ 
+static bool mausb_control_xfer(struct mausb_urb *maurb) 
+{ 
+ return (usb_endpoint_type(&maurb->urb->ep->desc) == 
+ USB_ENDPOINT_XFER_CONTROL && maurb->urb->setup_packet); 
+} 
+ 
+/** 
+ * Create and send OUT transferRequest packets for a given transfer. 
+ * 
+ * @tx_state: State associated with transfer. 
+ * @ep_state: State associated with transfer endpoint. 
+ * @maurb: MA USB urb associated with transfer. 
+ */ 
+int host_OUT_generate_txReqs(struct mausb_transfer_state *tx_state, 
+ struct mausb_ep_state *ep_state, struct mausb_urb *maurb) 
+{ 
+ int offset = 0; 
+ int pkt_length = 0; 
+ int payload_size = 0; 
+ int max_buffer_length = 0; 
+ struct mausb_pkt *tx_req; 
+ struct mausb_host_ep *ep = mausb_state_to_ep(ep_state); 
+ struct mausb_hcd *mhcd = mausb_host_ep_to_mahcd(ep); 
+ unsigned long irq_flags; 
+ 
+ /* 
+ * Always generate at least one OUT transferReq (OUT control 
+ * transfers may only contain setup data). 
+ */ 
+ do { 
+ /* create transferReq and set packet field values */ 
+ tx_req = mausb_create_dp(SUCCESS, maurb, MAUSB_OUT, 
+ MAUSB_HOST, GFP_ATOMIC); 
+ 
+ if (!tx_req) 
+ return -ENOMEM; 
+ 
+ mausb_fill_pkt_ep(tx_req, ep); 
+ tx_req->data->common.pkt_type = TransferReq; 
+ tx_req->data->req_id = ep_state->active_request_id; 
+ tx_req->data->seq_num = cpu_to_le32(ep_state->seq_number); 
+ tx_req->data->remaining_size_credit = 
+ cpu_to_le32(tx_state->rem_size); 
+ tx_req->buffer_length = 0; 
+ tx_req->nents = 0; 
+ 
+ /* add setup data (If necessary) */ 
+ if (mausb_pkt_has_setup_data(tx_req->data)) { 
+ tx_req->setup = (struct usb_ctrlrequest *) 
+ maurb->urb->setup_packet; 
+ } 
+ 
+ /* calculate max packet buffer size */ 
+ pkt_length = mausb_pkt_length(tx_req); 
+ max_buffer_length = MAUSB_MAX_PACKET_SIZE - pkt_length; 
+ payload_size = min_t(int, max_buffer_length, 
+ tx_state->rem_size); 
+ 
+ /* a control transfer can be empty, but nothing else */ 
+ if (payload_size <= 0 && 
+ !mausb_pkt_has_setup_data(tx_req->data)) { 
+ mausb_err(mhcd, "%s: packet error - no room for " 
+ "payload (buffer size is %i)\n", __func__, 
+ payload_size); 
+ return -ENOBUFS; 
+ } else if (payload_size > 0) { 
+ 
+ if (!maurb->urb->transfer_buffer) { 
+ mausb_err(mhcd, "%s: no transfer buffer\n", 
+ __func__); 
+ } 
+ 
+ /* create packet buffer and fill */ 
+ tx_req->buffer = maurb->urb->transfer_buffer + offset; 
+ if (!tx_req->buffer) { 
+ mausb_free_pkt(tx_req); 
+ return -ENOMEM; 
+ } 
+ 
+ tx_req->buffer_length = payload_size; 
+ } 
+ 
+ /* update state variables */ 
+ offset += payload_size; 
+ tx_state->rem_size -= payload_size; 
+ tx_req->data->remaining_size_credit = tx_state->rem_size; 
+ 
+ /* send transferReq packet to device */ 
+ host_OUT_send_txReq(tx_state, ep_state, tx_req); 
+ 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ ep_state->seq_number = 
+ mausb_seq_num_add(ep_state->seq_number, 1); 
+ list_add_tail(&tx_req->pkt_list, &ep->req_list); 
+ 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ 
+ } while (tx_state->rem_size > 0); 
+ 
+ return 0; 
+} 
+ 
+/** 
+ * Updates transfer and endpoint states after a transferResp is received. 
+ * 
+ * @ep_state: State information for enpoint associated with transfer. 
+ * @tx_state: State information for transfer in progress. 
+ * @tx_resp: transferResponse packet that has been received. 
+ * 
+ * Called whenever a transferResp packet is received. Returns size in bytes 
+ * of payload transferred. 
+ */ 
+int host_OUT_txResp_rcvd(struct mausb_ep_state *ep_state, 
+ struct mausb_transfer_state *tx_state, 
+ struct mausb_pkt *tx_resp) 
+{ 
+ int payload_size = 0; 
+ u8 status = tx_resp->common->pkt_status; 
+ u8 ep_flags = tx_resp->data->eps_tflags; 
+ u32 SN = le32_to_cpu(tx_resp->data->seq_num); 
+ u32 credit = le32_to_cpu( 
+ tx_resp->data->remaining_size_credit); 
+ struct mausb_host_ep *ep = mausb_state_to_ep(ep_state); 
+ struct mausb_urb *maurb = container_of(tx_state, 
+ struct mausb_urb, state); 
+ struct mausb_hcd *mhcd = mausb_host_ep_to_mahcd(ep); 
+ unsigned long irq_flags; 
+ 
+ mausb_dbg(mhcd, "%s: received transferResponse with sequence number %i" 
+ " for transfer %i\n", __func__, SN, tx_resp->data->req_id); 
+ 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ /* look for sequence number and/or request ID errors */ 
+ if (should_drop_txResp(ep_state, tx_state, tx_resp, MAUSB_OUT)) { 
+ mausb_drop_packet(ep, tx_resp); 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ return payload_size; 
+ } 
+ 
+ switch (status) { 
+ case SUCCESS: 
+ /* look for and acknowledge end of transfer */ 
+ if (ep_flags & MAUSB_PKT_TFLAG_EOT) { 
+ 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ host_send_ack(tx_state, MAUSB_OUT, ep_state, 
+ SUCCESS, SN); 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ 
+ ep_state->earliest_request_id = 
+ mausb_req_id_add( 
+ ep_state->earliest_request_id, 1); 
+ ep_state->active_request_id = 
+ mausb_req_id_add( 
+ ep_state->active_request_id, 1); 
+ 
+ tx_state->eot_detected = true; 
+ tx_state->last_transfer_sn = SN; 
+ maurb->urb->actual_length += tx_state->payload_size; 
+ } 
+ 
+ ep_state->earliest_unacked = SN + 1; 
+ ep_state->rx_buf_size = credit - payload_size; 
+ break; 
+ case INVALID_REQUEST: 
+ mausb_dbg(mhcd, "%s: status = INVALID_REQUEST\n", __func__); 
+ /* TODO: start over with request number in packet */ 
+ break; 
+ case DROPPED_PACKET: 
+ mausb_dbg(mhcd, "%s: status = DROPPED_PACKET\n", __func__); 
+ /* fallthrough, same as MISSING_SEQUENCE_NUMBER */ 
+ case MISSING_SEQUENCE_NUMBER: 
+ mausb_dbg(mhcd, "%s: status = MISSING_SEQUENCE_NUMBER\n", 
+ __func__); 
+ mausb_resend_multi_packets(ep, &ep->req_list, 
+ le32_to_cpu(tx_resp->data->seq_num), irq_flags); 
+ break; 
+ case TRANSFER_PENDING: 
+ mausb_dbg(mhcd, "%s: status = TRANSFER_PENDING\n", __func__); 
+ /* TODO: reset transmission counter */ 
+ break; 
+ case TRANSFER_EP_STALL: 
+ mausb_dbg(mhcd, "%s: status = TRANSFER_EP_STALL\n", __func__); 
+ if (ep_flags & MAUSB_PKT_TFLAG_EOT) { 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ host_send_ack(tx_state, MAUSB_OUT, ep_state, 
+ TRANSFER_EP_STALL, SN); 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ 
+ tx_state->eot_detected = true; 
+ } 
+ break; 
+ case TRANSFER_CANCELLED: 
+ mausb_dbg(mhcd, "%s: status = TRANSFER_CANCELLED\n", 
+ __func__); 
+ break; 
+ case TRANSFER_DATA_BUFFER_ERROR: 
+ mausb_dbg(mhcd, "%s: status = TRANSFER_DATA_BUFFER_ERROR\n", 
+ __func__); 
+ break; 
+ default: 
+ tx_state->transfer_error = true; 
+ mausb_drop_packet(ep, tx_resp); 
+ break; 
+ } 
+ 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ 
+ return payload_size; 
+} 
+ 
+ 
+/* --------------------- Transfer interfaces ----------------------*/ 
+ 
+/** 
+ * Interface called to initiate an IN or OUT transfer. 
+ * 
+ * @ep: Host endpoint associated with transfer. 
+ * @maurb: maurb with payload to transfer. 
+ * NOTE: one maurb maps to one transfer. 
+ * @dir_in: Transfer direction. Set to one if IN (to host) or zero if OUT. 
+ * 
+ * Only one transfer can be in progress at a time for a particular endpoint. 
+ * When a transfer is in progress, the tx_pending flag for that endpoint is set 
+ * indicating that the endpoint is busy. 
+ */ 
+int start_ma_transfer(struct mausb_host_ep *ep, struct mausb_urb *maurb, 
+ int dir_in) 
+{ 
+ int tx_size; 
+ unsigned long irq_flags; 
+ char *tx_type; 
+ struct mausb_hcd *mhcd = mausb_host_ep_to_mahcd(ep); 
+ const struct usb_endpoint_descriptor *ep_desc; 
+ 
+ ep_desc = mausb_get_ep_des(ep); 
+ 
+ switch (usb_endpoint_type(ep_desc)) { 
+ case USB_ENDPOINT_XFER_CONTROL: 
+ tx_type = "control"; 
+ break; 
+ case USB_ENDPOINT_XFER_ISOC: 
+ tx_type = "isochronous"; 
+ break; 
+ case USB_ENDPOINT_XFER_BULK: 
+ tx_type = "bulk"; 
+ break; 
+ case USB_ENDPOINT_XFER_INT: 
+ tx_type = "interrupt"; 
+ break; 
+ default: 
+ tx_type = "unknown"; 
+ } 
+ 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ 
+ /* start a new transfer if there isn't one already in progress. */ 
+ if (ep->state.tx_pending == 0) { 
+ 
+ ep->state.tx_pending = 1; 
+ tx_size = maurb->urb->transfer_buffer_length; 
+ 
+ /* 
+ * Set this transfer as active transfer for endpoint - this 
+ * is how we will get active transfer info when we receive 
+ * transferRequests. 
+ */ 
+ ep->active_transfer = maurb; 
+ 
+ /* check to see if setup phase of control transfer */ 
+ if (mausb_control_xfer(maurb)) { 
+ ep->state.seq_number = 0; 
+ ep->state.earliest_unacked = 0; 
+ } 
+ 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ 
+ /* initiate transfer by direction */ 
+ if (dir_in) { 
+ mausb_dbg(mhcd, "%s: starting %s IN transfer for" 
+ " endpoint %u\n", __func__, tx_type, 
+ ep->ep_handle.ep_num); 
+ 
+ host_init_IN_transfer(&maurb->state, ep, maurb); 
+ 
+ } else { 
+ mausb_dbg(mhcd, "%s: starting %s OUT transfer for" 
+ " endpoint %u\n", __func__, tx_type, 
+ ep->ep_handle.ep_num); 
+ 
+ host_init_OUT_transfer(&maurb->state, ep, tx_size); 
+ host_OUT_generate_txReqs(&maurb->state, &ep->state, 
+ maurb); 
+ } 
+ spin_lock_irqsave(&ep->ep_lock, irq_flags); 
+ } 
+ spin_unlock_irqrestore(&ep->ep_lock, irq_flags); 
+ 
+ return -EINPROGRESS; 
+} 
+ 
+/** 
+ * Interface called to give a transferResp to the host for IN transfers. 
+ * 
+ * @pkt: transferResponse packet being received. 
+ * @context: Host endpoint associated with transfer. 
+ * 
+ * After an IN transfer is initiated, the host waits to receive transferResponse 
+ * packets from the device-side endpoint. When a transferResponse is received, 
+ * the host updates its transfer and endpoint states and copies the packet 
+ * payload into the maurb buffer associated with the tranfer. If the device 
+ * requests a transferAck packet, one is sent. 
+ */ 
+int complete_IN_transferRequest(struct ms_pkt *pkt, void *context) 
+{ 
+ int urb_stat; 
+ int length = 0; 
+ struct mausb_host_ep *ep; 
+ struct mausb_pkt *tx_resp; 
+ struct mausb_urb *maurb; 
+ struct mausb_transfer_state *tx_state; 
+ struct mausb_hcd *mhcd; 
+ 
+ if ((NULL == context) || (NULL == pkt)) { 
+ pr_err("%s: received NULL %s\n", __func__, 
+ context ? "packet" : "context"); 
+ return -EFAULT; 
+ } 
+ 
+ ep = (struct mausb_host_ep *) context; 
+ 
+ /* stop timeout timer */ 
+ del_timer(&ep->timer); 
+ 
+ tx_resp = mausb_pkt_from_ms_pkt_ep(pkt, ep, GFP_ATOMIC); 
+ list_add_tail(&tx_resp->pkt_list, &ep->resp_list); 
+ 
+ mhcd = mausb_host_ep_to_mahcd(ep); 
+ maurb = ep->active_transfer; 
+ 
+ if (NULL == maurb) { 
+ mausb_err(mhcd, "%s: no active transfer for endpoint at %p\n", 
+ __func__, ep); 
+ return -EINVAL; 
+ } 
+ 
+ tx_state = &maurb->state; 
+ length = host_IN_txResp_rcvd(&ep->state, tx_state, tx_resp); 
+ 
+ /* something went wrong in receiving the transferResp packet */ 
+ if (length < 0) { 
+ mausb_err(mhcd, "%s: returning error %i\n", __func__, length); 
+ return length; 
+ } 
+ 
+ /* look for end of transfer */ 
+ if (tx_state->eot_detected) { 
+ ep->state.tx_pending = 0; 
+ 
+ urb_stat = mausb_to_urb_status(tx_resp->data->common.pkt_status); 
+ if (NULL != maurb) 
+ mausb_unlink_giveback_urb(maurb, urb_stat); 
+ } 
+ 
+ /* if not end of transfer, set timer between packets */ 
+ else { 
+ mod_timer(&ep->timer, 
+ jiffies + msecs_to_jiffies(MAUSB_TRANSFER_KEEP_ALIVE)); 
+ } 
+ 
+ return length; 
+} 
+ 
+/** 
+ * Interface called to give the host a transferResp packet. 
+ * 
+ * @pkt: transferResponse packet being received. 
+ * @context: Host endpoint associated with transfer. 
+ * 
+ * For OUT transfers the host sends a series of transferRequest packets. A 
+ * transferResponse packet is only sent by the device when a transferAck packet 
+ * is requested by the host or the end of the transfer is reached. 
+ */ 
+int complete_OUT_transferRequest(struct ms_pkt *pkt, void *context) 
+{ 
+ int urb_stat; 
+ int ret = 0; 
+ struct mausb_host_ep *ep; 
+ struct mausb_pkt *tx_resp; 
+ struct mausb_urb *maurb; 
+ struct mausb_transfer_state *tx_state; 
+ struct mausb_hcd *mhcd; 
+ 
+ if ((NULL == context) || (NULL == pkt)) { 
+ pr_err("%s: received NULL %s\n", __func__, 
+ context ? "packet" : "context"); 
+ return -EFAULT; 
+ } 
+ 
+ ep = (struct mausb_host_ep *) context; 
+ 
+ /* stop timeout timer */ 
+ del_timer(&ep->timer); 
+ 
+ tx_resp = mausb_pkt_from_ms_pkt_ep(pkt, ep, GFP_ATOMIC); 
+ list_add_tail(&tx_resp->pkt_list, &ep->resp_list); 
+ 
+ mhcd = mausb_host_ep_to_mahcd(ep); 
+ maurb = ep->active_transfer; 
+ 
+ if (NULL == maurb) { 
+ mausb_err(mhcd, "%s: no active transfer for endpoint at %p\n", 
+ __func__, ep); 
+ return -EFAULT; 
+ } 
+ 
+ tx_state = &maurb->state; 
+ 
+ /* 
+ * Look for Retry flag in packet and resend requested packets 
+ * if we have them. Otherwise, pass packet on to receiving process. 
+ */ 
+ if (mausb_is_a_retry(ep, &ep->req_list, tx_resp) == false) 
+ ret = host_OUT_txResp_rcvd(&ep->state, tx_state, tx_resp); 
+ 
+ /* make sure we still have an active transfer */ 
+ if (!ep->active_transfer) { 
+ mausb_cleanup_ma_packets(ep, 
+ le32_to_cpu(tx_resp->data->seq_num), 
+ tx_resp->data->req_id); 
+ mausb_unlink_giveback_urb(maurb, -EINVAL); 
+ return ret; 
+ } 
+ 
+ /* handle end of transfer */ 
+ if (tx_state->eot_detected) { 
+ ep->state.tx_pending = 0; 
+ mausb_cleanup_ma_packets(ep, 
+ le32_to_cpu(tx_resp->data->seq_num), 
+ tx_resp->data->req_id); 
+ urb_stat = mausb_to_urb_status( 
+ tx_resp->data->common.pkt_status); 
+ mausb_unlink_giveback_urb(maurb, urb_stat); 
+ } 
+ 
+ return ret; 
+} 
+ 
+/* 
+ * Receives transferRequest packets for control endpoint (ep0). 
+ * 
+ * @pkt: transferResponse packet being received. 
+ * @context: Host endpoint associated with transfer. This should always be 
+ * control endpoint (ep0). 
+ * 
+ * Control transfers can be either IN or OUT. Transfer direction is parsed 
+ * from the urb associated with the transfer, then the appropriate completion 
+ * function is called. 
+ */ 
+int complete_control_transferRequest(struct ms_pkt *pkt, void *context) 
+{ 
+ int dir_in = 0; 
+ struct mausb_host_ep *ep; 
+ struct mausb_hcd *mhcd; 
+ 
+ if ((NULL == context) || (NULL == pkt)) { 
+ pr_err("%s: received NULL %s\n", __func__, 
+ context ? "packet" : "context"); 
+ return -EFAULT; 
+ } 
+ 
+ ep = (struct mausb_host_ep *) context; 
+ mhcd = mausb_host_ep_to_mahcd(ep); 
+ 
+ if (NULL == mhcd) { 
+ pr_err("%s: could not find MA USB HCD for endpoint" 
+ " at 0x%p\n", __func__, ep); 
+ return -EFAULT; 
+ } 
+ 
+ if (NULL == ep->active_transfer || NULL == ep->active_transfer->urb) { 
+ mausb_err(mhcd, "%s: no active transfer for endpoint at %p\n", 
+ __func__, ep); 
+ return -EFAULT; 
+ } 
+ 
+ /* stop timeout timer */ 
+ del_timer(&ep->timer); 
+ 
+ dir_in = usb_pipein(ep->active_transfer->urb->pipe); 
+ 
+ if (dir_in) 
+ complete_IN_transferRequest(pkt, context); 
+ else 
+ complete_OUT_transferRequest(pkt, context); 
+ 
+ return 0; 
+} 
+ 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_udc.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_udc.c
